%global bits 32
%global debug_package %{nil}

%ifarch x86_64 ppc64 s390x sparc64
%global bits 64
%endif
%global namedreltag -rc-2
%global namedversion %{version}%{?namedreltag}

Name:          native-platform
Version:       0.3
Release:       0.3.rc2%{?dist}
Summary:       Java bindings for various native APIs
License:       ASL 2.0
URL:           https://github.com/adammurdoch/native-platform
# git clone git://github.com/adammurdoch/native-platform native-platform-0.3-rc-2
# (cd native-platform-0.3-rc-2/ && git archive --format=tar --prefix=native-platform-0.3-rc-2/ 0.3-rc-2 | xz > ../native-platform-0.3-rc-2-src-git.tar.xz)
Source0:       https://github.com/adammurdoch/native-platform/archive/%{namedversion}.tar.gz
Source1:       http://repo.gradle.org/gradle/libs-releases-local/net/rubygrapefruit/%{name}/%{namedversion}/%{name}-%{namedversion}.pom
Source2:       http://repo.gradle.org/gradle/libs-releases-local/net/rubygrapefruit/%{name}-linux-i386/%{namedversion}/%{name}-linux-i386-%{namedversion}.pom
Source3:       http://repo.gradle.org/gradle/libs-releases-local/net/rubygrapefruit/%{name}-linux-amd64/%{namedversion}/%{name}-linux-amd64-%{namedversion}.pom
# From Debian
Source4:       %{name}-Makefile
# Try to load native library first from /usr/lib*/native-platform
# instead of extractDir or classpath.
Patch0:        %{name}-0.3-rc-2-NativeLibraryLocator.patch
# Use generate libraries without arch references
Patch1:        %{name}-0.3-rc-2-native-libraries-name.patch
# Add support for arm and other x64 arches
Patch2:        %{name}-0.3-rc-2-Platform.patch

# build tools and deps
BuildRequires: java-devel
BuildRequires: javapackages-tools
BuildRequires: jopt-simple
BuildRequires: ncurses-devel
Requires:      javapackages-tools
Requires:      java

%description
A collection of cross-platform Java APIs
for various native APIs.

These APIs support Java 5 and later. Some
of these APIs overlap with APIs available
in later Java versions.

%package javadoc
Summary:       Javadoc for %{name}
BuildArch:     noarch

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{namedversion}
find .  -name "*.jar" -delete
find .  -name "*.class" -delete

%patch0 -p0
%patch1 -p0
%patch2 -p0

cp -p %{SOURCE1} pom.xml
cp -p %{SOURCE4} Makefile

%pom_remove_dep net.rubygrapefruit:%{name}-osx-universal pom.xml
%pom_remove_dep net.rubygrapefruit:%{name}-windows-i386 pom.xml
%pom_remove_dep net.rubygrapefruit:%{name}-windows-amd64 pom.xml
%if %{bits} == 64
%pom_remove_dep net.rubygrapefruit:%{name}-linux-i386 pom.xml
%else
%pom_remove_dep net.rubygrapefruit:%{name}-linux-amd64 pom.xml
%endif

chmod 644 readme.md
sed -i 's/\r//' readme.md

%build

CFLAGS="${CFLAGS:-%optflags}" ; export CFLAGS ;
CPPFLAGS="${CPPFLAGS:-%optflags}" ; export CPPFLAGS ;
CXXFLAGS="${CXXFLAGS:-%optflags}" ; export CXXFLAGS ;
LDFLAGS="${LDFLAGS:-%__global_ldflags}"; export LDFLAGS;
make %{?_smp_mflags} JAVA_HOME=%{_jvmdir}/java

%install

mkdir -p %{buildroot}%{_javadir}
install -m 644 build/%{name}.jar %{buildroot}%{_javadir}/%{name}.jar

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_maven_depmap JPP-%{name}.pom %{name}.jar

mkdir -p %{buildroot}%{_jnidir}
install -pm 644 build/%{name}-linux.jar %{buildroot}%{_jnidir}/

%if %{bits} == 64
install -pm 644 %{SOURCE3} %{buildroot}%{_mavenpomdir}/JPP-%{name}-linux.pom
%add_maven_depmap JPP-%{name}-linux.pom %{name}-linux.jar
%else
install -pm 644 %{SOURCE2} %{buildroot}%{_mavenpomdir}/JPP-%{name}-linux.pom
%add_maven_depmap JPP-%{name}-linux.pom %{name}-linux.jar
%endif

mkdir -p %{buildroot}%{_libdir}/%{name}
install -pm 0755 build/binaries/libnative-platform-curses.so %{buildroot}%{_libdir}/%{name}
install -pm 0755 build/binaries/libnative-platform.so %{buildroot}%{_libdir}/%{name}
#ln -sf %%{_jnidir}/%%{name}-linux.jar %%{buildroot}%%{_libdir}/%%{name}/%%{name}-linux.jar
#ln -sf %%{_javadir}/%%{name}.jar %%{buildroot}%%{_libdir}/%%{name}/%%{name}.jar

mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -rp build/docs/javadoc/* %{buildroot}%{_javadocdir}/%{name}

%files
%{_javadir}/%{name}.jar
%{_jnidir}/%{name}-linux.jar
%{_libdir}/%{name}
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavenpomdir}/JPP-%{name}-linux.pom
%{_mavendepmapfragdir}/%{name}
%doc readme.md LICENSE

%files javadoc
%{_javadocdir}/%{name}
%doc LICENSE

%changelog
* Tue Oct 15 2013 gil cattaneo <puntogil@libero.it> 0.3-0.3.rc2
- fix for rhbz#992323
- use make as buildsystem to avoid circular dependencies
- removed arch references from installed native jar

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3-0.3.rc2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu May 09 2013 gil cattaneo <puntogil@libero.it> 0.3-0.2.rc2
- removed unnecessary references to jpackage-utils and gcc-c++

* Tue Apr 30 2013 gil cattaneo <puntogil@libero.it> 0.3-0.1.rc2
- update to 0.3-rc-2

* Thu Dec 13 2012 gil cattaneo <puntogil@libero.it> 0.2-1
- initial rpm